//+------------------------------------------------------------------+
//|                                               ZigZag Pointer.mq4 |
//|                                    zigzag modified by Dr. Gaines |
//|                                      dr_richard_gaines@yahoo.com |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "dr_richard_gaines"
#property link      "http://www.metaquotes.net/"
//Fib levels added by cja

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_width1 1
#property indicator_color2 Red
#property indicator_width2 1 
//---- indicator parameters
extern int ExtDepth=100;
extern int ExtDeviation=75;
extern int ExtBackstep=15;

extern color FiboLineColor = Gold;
extern int FiboLineStyle = 0; 
extern int FiboLineWidth = 0;
//---- indicator buffers
double ExtMapBuffer[];
double ExtMapBuffer2[];
int OldLastZigZag, OldPreviousZigZag;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(2);
//---- drawing settings
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0, 233);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1, 234);  
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtMapBuffer);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(0,0.0);
   
//---- indicator short name
   IndicatorShortName("ZigZag("+ExtDepth+","+ExtDeviation+","+ExtBackstep+")");
//---- initialization done
   return(0);
  }
  
  int deinit()
{
   ObjectDelete("LongFibo");
   ObjectDelete("ShortFibo");
   
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int    shift, back,lasthighpos,lastlowpos;
   double val,res;
   double curlow,curhigh,lasthigh,lastlow;

   for(shift=Bars-ExtDepth; shift>=0; shift--)
     {
      val=Low[Lowest(NULL,0,MODE_LOW,ExtDepth,shift)];
      if(val==lastlow) val=0.0;
      else 
        { 
         lastlow=val; 
         if((Low[shift]-val)>(ExtDeviation*Point)) val=0.0;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=ExtMapBuffer[shift+back];
               if((res!=0)&&(res>val)) ExtMapBuffer[shift+back]=0.0; 
              }
           }
        } 
      ExtMapBuffer[shift]=val;
      //--- high
      val=High[Highest(NULL,0,MODE_HIGH,ExtDepth,shift)];
      if(val==lasthigh) val=0.0;
      else 
        {
         lasthigh=val;
         if((val-High[shift])>(ExtDeviation*Point)) val=0.0;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=ExtMapBuffer2[shift+back];
               if((res!=0)&&(res<val)) ExtMapBuffer2[shift+back]=0.0; 
              } 
           }
        }
      ExtMapBuffer2[shift]=val;
     }

   // final cutting 
   lasthigh=-1; lasthighpos=-1;
   lastlow=-1;  lastlowpos=-1;

   for(shift=Bars-ExtDepth; shift>=0; shift--)
     {
      curlow=ExtMapBuffer[shift];
      curhigh=ExtMapBuffer2[shift];
      if((curlow==0)&&(curhigh==0)) continue;
      //---
      if(curhigh!=0)
        {
         if(lasthigh>0) 
           {
            if(lasthigh<curhigh) ExtMapBuffer2[lasthighpos]=0;
            else ExtMapBuffer2[shift]=0;
           }
         //---
         if(lasthigh<curhigh || lasthigh<0)
           {
            lasthigh=curhigh;
            lasthighpos=shift;
           }
         lastlow=-1;
        }
      //----
      if(curlow!=0)
        {
         if(lastlow>0)
           {
            if(lastlow>curlow) ExtMapBuffer[lastlowpos]=0;
            else ExtMapBuffer[shift]=0;
           }
         //---
         if((curlow<lastlow)||(lastlow<0))
           {
            lastlow=curlow;
            lastlowpos=shift;
           } 
         lasthigh=-1;
        }
     }
  
   for(shift=Bars-1; shift>=0; shift--)
     {
      if(shift>=Bars-ExtDepth) ExtMapBuffer[shift]=0.0;
      else
        {
         res=ExtMapBuffer2[shift];
         if(res!=0.0) ExtMapBuffer2[shift]=res;
        }
  	int i=0;
  	int LastZigZag, PreviousZigZag;
   
   int h=0;
   while ( ExtMapBuffer[h]==0 && ExtMapBuffer2[h]==0) {
   	h++;
   }
   
   LastZigZag=h;
   
   h++;
   while(ExtMapBuffer[h]==0 && ExtMapBuffer2[h]==0) {
   	h++;
   }
   
   PreviousZigZag=h;
   
   if (OldLastZigZag!=LastZigZag || OldPreviousZigZag!=PreviousZigZag) {
   	if(OldLastZigZag>LastZigZag) Alert("Possible change in direction... (M",Period()," ",Symbol(),")");
    	OldLastZigZag=LastZigZag;
   	OldPreviousZigZag=PreviousZigZag;
   	//ObjectDelete("Fibo");
   	//ObjectCreate("Fibo", OBJ_FIBO, 0, Time[PreviousZigZag], ExtMapBuffer[LastZigZag], Time[LastZigZag], ExtMapBuffer[PreviousZigZag]);
  }
   if (OldLastZigZag!=LastZigZag || OldPreviousZigZag!=PreviousZigZag) {
   	if(OldLastZigZag<LastZigZag) Alert("Possible change in direction... (M",Period()," ",Symbol(),")");
   	OldLastZigZag=LastZigZag;
   	OldPreviousZigZag=PreviousZigZag;
   	//ObjectDelete("Fibo");
   	//ObjectCreate("Fibo", OBJ_FIBO, 0, Time[PreviousZigZag], ExtMapBuffer[LastZigZag], Time[LastZigZag], ExtMapBuffer[PreviousZigZag]);
   }
   
   
	if(ObjectFind("LongFibo") == -1)
		ObjectCreate("LongFibo",OBJ_FIBO,0, Time[PreviousZigZag], ExtMapBuffer[LastZigZag], Time[LastZigZag],ExtMapBuffer2[PreviousZigZag]);
	else
	{
		ObjectSet("LongFibo",OBJPROP_TIME2, Time[PreviousZigZag]);
		ObjectSet("LongFibo",OBJPROP_TIME1,  Time[LastZigZag]);
		ObjectSet("LongFibo",OBJPROP_PRICE1, ExtMapBuffer[LastZigZag]);
		ObjectSet("LongFibo",OBJPROP_PRICE2, ExtMapBuffer2[PreviousZigZag]);
	}
   ObjectSet("LongFibo",OBJPROP_LEVELCOLOR,FiboLineColor);
   ObjectSet("LongFibo",OBJPROP_LEVELSTYLE,FiboLineStyle);
   ObjectSet("LongFibo",OBJPROP_LEVELWIDTH,FiboLineWidth);
   ObjectSet("LongFibo",OBJPROP_FIBOLEVELS,7);
   ObjectSet("LongFibo",OBJPROP_FIRSTLEVEL+0,0.000);	ObjectSetFiboDescription("LongFibo",0," 0.000 -  %$  ");
   ObjectSet("LongFibo",OBJPROP_FIRSTLEVEL+1,0.236);	ObjectSetFiboDescription("LongFibo",1," 0.236 -  %$  "); 
   ObjectSet("LongFibo",OBJPROP_FIRSTLEVEL+2,0.382);	ObjectSetFiboDescription("LongFibo",2," 0.382 -  %$  "); 
   ObjectSet("LongFibo",OBJPROP_FIRSTLEVEL+3,0.500);	ObjectSetFiboDescription("LongFibo",3," 0.500 -  %$  "); 
   ObjectSet("LongFibo",OBJPROP_FIRSTLEVEL+4,0.618);	ObjectSetFiboDescription("LongFibo",4," 0.618 -  %$  ");
   ObjectSet("LongFibo",OBJPROP_FIRSTLEVEL+5,0.764);	ObjectSetFiboDescription("LongFibo",5," 0.764 -  %$  "); 
   ObjectSet("LongFibo",OBJPROP_FIRSTLEVEL+6,1.000);	ObjectSetFiboDescription("LongFibo",6," 1.000 -  %$  "); 
   ObjectSet("LongFibo",OBJPROP_RAY,true);
   ObjectSet("LongFibo",OBJPROP_BACK,true);
   
   
   	if(ObjectFind("ShortFibo") == -1)
		ObjectCreate("ShortFibo",OBJ_FIBO,0, Time[LastZigZag], ExtMapBuffer[PreviousZigZag], Time[PreviousZigZag],ExtMapBuffer2[LastZigZag]);
	else
	{
		ObjectSet("ShortFibo",OBJPROP_TIME2, Time[LastZigZag]);
		ObjectSet("ShortFibo",OBJPROP_TIME1,  Time[PreviousZigZag]);
		ObjectSet("ShortFibo",OBJPROP_PRICE1, ExtMapBuffer[PreviousZigZag]);
		ObjectSet("ShortFibo",OBJPROP_PRICE2, ExtMapBuffer2[LastZigZag]);
	}
   ObjectSet("ShortFibo",OBJPROP_LEVELCOLOR,FiboLineColor);
   ObjectSet("ShortFibo",OBJPROP_LEVELSTYLE,FiboLineStyle);
   ObjectSet("ShortFibo",OBJPROP_LEVELWIDTH,FiboLineWidth);
   ObjectSet("ShortFibo",OBJPROP_FIBOLEVELS,7);
   ObjectSet("ShortFibo",OBJPROP_FIRSTLEVEL+0,1.000);	ObjectSetFiboDescription("ShortFibo",0," 0.000 -  %$  ");
   ObjectSet("ShortFibo",OBJPROP_FIRSTLEVEL+1,0.764);	ObjectSetFiboDescription("ShortFibo",1," 0.236 -  %$  "); 
   ObjectSet("ShortFibo",OBJPROP_FIRSTLEVEL+2,0.618);	ObjectSetFiboDescription("ShortFibo",2," 0.382 -  %$  "); 
   ObjectSet("ShortFibo",OBJPROP_FIRSTLEVEL+3,0.500);	ObjectSetFiboDescription("ShortFibo",3," 0.500 -  %$  "); 
   ObjectSet("ShortFibo",OBJPROP_FIRSTLEVEL+4,0.382);	ObjectSetFiboDescription("ShortFibo",4," 0.618 -  %$  ");
   ObjectSet("ShortFibo",OBJPROP_FIRSTLEVEL+5,0.236);	ObjectSetFiboDescription("ShortFibo",5," 0.764 -  %$  "); 
   ObjectSet("ShortFibo",OBJPROP_FIRSTLEVEL+6,0.000);	ObjectSetFiboDescription("ShortFibo",6," 1.000 -  %$  "); 
   ObjectSet("ShortFibo",OBJPROP_RAY,true);
   ObjectSet("ShortFibo",OBJPROP_BACK,true);


     }
  }
  
  //end//